/* Class: BListe
 * Author: Umut BENZER
 * 
 * ncelikli ve normal kuyruk oluturmak iin kullanlan snftr.
 * ncelikli ya da normal olaca constructordaki oncelikli
 * ifadesinin deerine gre belirlenir.
 * 
 * Kuyruk ile ncelikli kuyruk metotlar arasnda ok ufak farklar
 * olduu iin ikisini birleik yapmak uygun grmtr.
 */

public class BListe {
	private Musteri bas; // Kuyruun ilk elemannn referans
	private Musteri son; // Kuyruun son elemannn referans
	private boolean oncelikli; // Kuyruun zellii

	/* lk yaratldnda bo olan bir kuyruk */
	public BListe() {
		bas = null;
		son = null;
		oncelikli = false;
	}

	public BListe(boolean oncelikli) {
		this.oncelikli = oncelikli;
		bas = null;
		son = null;
	}

	/*
	 * Mteri nesnesini gelen verilere uygun bir ekilde yaratr ve ekle
	 * metoduna gnderir.
	 */
	public void ekle(int musteriNo, int islemSuresi, int FIFOBeklemeSuresi) {
		Musteri yeniMusteri = new Musteri(musteriNo, islemSuresi,
				FIFOBeklemeSuresi);
		ekle(yeniMusteri);
	}

	public void ekle(int musteriNo, int islemSuresi) {
		Musteri yeniMusteri = new Musteri(musteriNo, islemSuresi);
		ekle(yeniMusteri);
	}

	/*
	 * Mteriyi listenin ncelikli olup olmama durumuna uygun bir ekilde
	 * kuyruun uygun yerine ya da sonuna atar.
	 */
	private void ekle(Musteri yeniMusteri) {
		if (oncelikli) {
			Musteri onceki = null;
			Musteri etkin = bas;

			while (etkin != null && yeniMusteri.islemSuresi > etkin.islemSuresi) {
				onceki = etkin;
				etkin = etkin.sonraki;
			}

			if (onceki == null) {
				bas = yeniMusteri;
			} else {
				onceki.sonraki = yeniMusteri;
			}
			yeniMusteri.sonraki = etkin;

		} else {

			if (son != null) {
				son.sonraki = yeniMusteri;
				son = yeniMusteri;
			} else {
				bas = yeniMusteri;
				son = yeniMusteri;
			}
		}

	}

	/* Sradaki mteriyi al ve kar */
	public Musteri cikar() {
		Musteri dondurulecek = bas;
		if (bas != null) {
			bas = bas.sonraki;
		}
		return dondurulecek;
	}

	/* Kuyruun bitip bitmediini dndrr. */
	public boolean bosMu() {
		return (bas == null ? true : false);
	}

}
